/* SPDX-License-Identifier: BSD-3-Clause */

#ifndef __SO_CONSUMER_H__
#define __SO_CONSUMER_H__

#include <stdio.h>
#include "ring_buffer.h"
#include "packet.h"

typedef struct so_consumer_ctx_t {
	struct so_ring_buffer_t *producer_rb;
	const char *filename;

	/* TODO: add synchronization primitives for timestamp ordering */
	FILE *f;
	pthread_mutex_t logs;
	pthread_mutex_t timestamp;
	unsigned long lasttimestamp;
} so_consumer_ctx_t;

int create_consumers(pthread_t *tids,
	int num_consumers,
	so_ring_buffer_t *rb,
	const char *out_filename);

#endif /* __SO_CONSUMER_H__ */
